#include <avr/ina90.h>			// dient der Anpassung IAR-Compilerspezifischen Anweisungen an den GCC-Compiler
#include <avr/io.h>
#include <avr/interrupt.h>		// dient dazu Interrupts auswerten zu knnen
#include <avr/signal.h>			// genau so wichtig fr die Interruptroutinen wie <interrupt.h>
#include "example.H"


time_struct time;               //Globale struct



SIGNAL (SIG_OVERFLOW1) // diese Zeile musste auf den GCC-Compiler angepasst werden
{	
  --time.t_count;
  if (0x0000 == time.t_count)	// decrement t_count at each interruptcall
    {
		++time.sec;
		if ( 60 == time.sec )	// increment seconds after t_count was zero
		{
			++time.min;
			if ( 60 == time.min )	//increment minute after 60 seconds 
			{
				++time.hour;
				if ( 24 == time.hour )	//increment hour after 60 minutes
				{
					time.hour = 0x00;	// set hour to zero after 24 hours
				}
				time.min = 0x00;	// set minute to zero after 60 minutes
			}
			time.sec = 0x00;	// set seconds to zero after 60 seconds
		}
			if (time.sec % 2)
				CLRBIT(PORTB,(LED0+LED1+LED2+LED3));		// LEDs on
			else
				SETBIT(PORTB,(LED0+LED1+LED2+LED3));		// LEDs off


		// This is 4,000,000 Hz/510 = XXX Hz (Max PWM frequency)
		time.t_count = 0x1EA3;
	}
}



void Setup(void)
{
// definition of PWM, Ports, UART and Real-Time-Clock

  TCCR1A  = 0x81;         // define timer1 as 8-bit PWM
  TIFR    = 0x04;         // clear counter1 overflow flag
  //TIMSK   = 0x04;       // enable counter1 overflow interrupt ***
						  // "enable OVF1" wird nach der globalen Freischaltung gemacht !!!
  TCNT1   = 0x00;         // set counter1 to zero
  TCCR1B  = 0x01;         // PWM disabLED

  PORTC   = 0x00;         // Prepare Port C as analog input
  DDRC    = 0x00;         // with no pull-ups

  PORTB   = 0xFF;         // Turn of Leds on Port B = Turn on internal pull-ups
  DDRB    = 0xFF;         // 

  PORTD   = 0xFF;         // Turn on internal pull-ups for PORTD
  DDRD    = 0xFF;		  // Set PORTB as output




  time.sec = 0x00;
  time.min = 0x00;
  time.hour = 0x00;
  time.t_count = 0x3AD2;

  timer_enable_int (1 << TOIE1);  			// freischalten des counter1 Overflow Interrupts (BK 9.12.03)

  sei();                					// global interrupt enable vorher"_SEI()" ist aber IAR-Syntax


}



int main(void)
{
    Setup();				// Initialisierung des Mikrocontrollers

	
    
    SETBIT(PORTB,(LED0+LED1+LED2+LED3+LED4+LED5+LED6+LED7));	   // Turn all LEDs off
    
	//    while ((PINA & (1<<SWSTART)));           // Wait until SWSTART is pushed
	
	TCCR1B = 0x01;	//start Timer1
	
	for(;;);		// endless loop
    
    
}